// Commands.h : Declaration of the CCommands

#ifndef __COMMANDS_H_
#define __COMMANDS_H_

#include "..\resource.h"       // main symbols
#include "VCEventHandler.h"

/////////////////////////////////////////////////////////////////////////////
// CCommands

class XDebuggerEvents;
class CVC6Extend;

class ATL_NO_VTABLE CCommands : 
	public CComObjectRootEx<CComMultiThreadModel>,
	public CComCoClass<CCommands, &CLSID_Commands>,
	public IDispatchImpl<ICommands, &IID_ICommands, &LIBID_VC6EXTENDLib>
{
public:

DECLARE_NOT_AGGREGATABLE(CCommands)

BEGIN_COM_MAP(CCommands)
	COM_INTERFACE_ENTRY(ICommands)
	COM_INTERFACE_ENTRY(IDispatch)
END_COM_MAP()

	friend class CVC6Extend;
public:

	CCommands();
	~CCommands();
public:
	void OnConnection(IApplication* pApplication);
	void OnDisconnection();

	IApplication*	GetApplicationObject()		{ return m_piApplication; }
	
	IDebugger*		GetDebuggerObject()			{ return m_pDebugger; }
protected:
	void			CleanUp();
private:
	CComPtr<IApplication>	m_piApplication;
	XDebuggerEventsObj*		m_pDebuggerEventsObj;
	IDebugger*				m_pDebugger;
// ICommands
public:
	STDMETHOD(SampleCommand)();
};

typedef CComObject<CCommands> CCommandsObj;

#endif //__COMMANDS_H_
