// DSAddin.cpp : Implementation of CVC6Extend
#include "stdafx.h"
#include "VC6Extend.h"
#include "VC6ExtendAddin.h"

#include "VCAddinManager.h"

/////////////////////////////////////////////////////////////////////////////
// CVC6Extend

///////////////////////////////////////////////////////////////////////////////
// IDSAddin

STDMETHODIMP CVC6Extend::OnConnection(IApplication* piApplication, VARIANT_BOOL bFirstTime, long dwCookie, VARIANT_BOOL* pbOnConnection)
{
	// prepare to fail!
	*pbOnConnection = VARIANT_FALSE;

	// create our command object
	CCommandsObj::CreateInstance(&m_pCommands);
	m_pCommands->OnConnection(piApplication);
	CComQIPtr<IDispatch> piDispCmds = m_pCommands;

	// tell VC about us:
	if (FAILED(piApplication->SetAddInInfo((long)_Module.GetModuleInstance(), piDispCmds, IDR_TOOLBAR_MEDIUM, IDR_TOOLBAR_LARGE, dwCookie)))
		return S_OK;

	// register our commands with VC
	VARIANT_BOOL bRet;
	_bstr_t		 bstrCmd,
					 bstrSampleCommand = "SampleCommand";

	// SampleCommand
	bstrCmd = "SampleCommand\nSampleCommand\nA Sample Addin Command\nSampleCommand";
	if (FAILED(piApplication->AddCommand(bstrCmd, bstrSampleCommand, 0, dwCookie, &bRet) || VARIANT_FALSE == bRet))
		return S_OK;

	// create toolbar:
	if (VARIANT_TRUE == bFirstTime)
	{
		piApplication->AddCommandBarButton(dsGlyph, bstrSampleCommand, dwCookie);
	}

	// success
	*pbOnConnection = VARIANT_TRUE;

	return S_OK;
}

STDMETHODIMP CVC6Extend::OnDisconnection(VARIANT_BOOL bLastTime)
{
	// cleanup!
	if ( m_pCommands )
	{
		m_pCommands->OnDisconnection();
		m_pCommands = NULL;
	}

	return S_OK;
}
