// VCAddinManager.cpp: implementation of the CVCAddinManager class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VCAddinManager.h"
#include "VCLineNumberModule.h"

CVCAddinManager* g_pAddinManager = NULL;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVCAddinManager::CVCAddinManager()
{
	ASSERT( !g_pAddinManager );
	g_pAddinManager = this;
	m_arrModules.Add( new CVCLineNumberModule );

	int nModuleSize = m_arrModules.GetSize();
	for (int ii = 0; ii < nModuleSize; ++ii)
	{
		IVCExtendModule* pModule = m_arrModules[ii];
		pModule->Init();
	}
}

CVCAddinManager::~CVCAddinManager()
{
	int nModuleSize = m_arrModules.GetSize();
	for (int ii = 0; ii < nModuleSize; ++ii)
	{
		IVCExtendModule* pModule = m_arrModules[ii];
		pModule->ShutDown();
		delete pModule;
	}

	g_pAddinManager = NULL;
}
