#ifndef VCEventHandler_h__
#define VCEventHandler_h__

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <ObjModel\dbgguid.h>
#include "VC6EXTEND.h"

struct __declspec(uuid("{34C6301A-AE64-11cf-AB59-00AA00C091A1}")) IDebuggerEvents;

DEFINE_GUID(CLSID_DebuggerEvents, 0x6A06C127,0x4748,0x11D1,0xBC,0x91,0x00,0x00,0x01,0x00,0x16,0xA6);

//DEFINE_GUID(LIBID_GDIWatch,0x6A06C128,0x4748,0x11D1,0xBC,0x91,0x00,0x00,0x01,0x00,0x16,0xA6);

class CCommands;

// This class template is used as the base class for the Application
// event handler object and the Debugger event handler object,
// which are declared below.
template <class IEvents, const IID* piidEvents, const GUID* plibid, class XEvents, const CLSID* pClsidEvents>
class XEventHandler :	public CComDualImpl<IEvents, piidEvents, plibid>,
						public CComObjectRoot,
						public CComCoClass<XEvents, pClsidEvents>
{
public:
	BEGIN_COM_MAP(XEvents)
		COM_INTERFACE_ENTRY(IDispatch)
		COM_INTERFACE_ENTRY_IID(*piidEvents, IEvents)
	END_COM_MAP()
			
	DECLARE_NOT_AGGREGATABLE(XEvents)
			
	XEventHandler()
	{
		m_pCommands = NULL;
	}
	
	void Connect(IUnknown* pUnk)
	{
		VERIFY(SUCCEEDED(AtlAdvise(pUnk, this, *piidEvents, &m_dwAdvise)));
	}
	
	void Disconnect(IUnknown* pUnk)
	{
		AtlUnadvise(pUnk, *piidEvents, m_dwAdvise);
	}
	
	CCommands* m_pCommands;
	
protected:
	DWORD m_dwAdvise;
};

// This object handles events fired by the Application object
class XDebuggerEvents : public XEventHandler<IDebuggerEvents, &IID_IDebuggerEvents, &LIBID_VC6EXTENDLib, XDebuggerEvents, &CLSID_DebuggerEvents>
{
public:
	// IDebuggerEvents method
	STDMETHOD(BreakpointHit)(THIS_ IDispatch * pBreakpoint);
};
typedef CComObject<XDebuggerEvents> XDebuggerEventsObj;

#endif // VCEventHandler_h__