// VCLineNumberModule.h: interface for the CVCLineNumberModule class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VCLINENUMBERMODULE_H__D308D456_3541_41CB_BFFB_44E4A97A809A__INCLUDED_)
#define AFX_VCLINENUMBERMODULE_H__D308D456_3541_41CB_BFFB_44E4A97A809A__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "VCExtendModule.h"


class CVCLineNumberWnd;

/*----------------------------------------------------------------------------*/
/* CVCLineNumberModule
/*----------------------------------------------------------------------------*/
class CVCLineNumberModule : public IVCExtendModule
{
public:
	CVCLineNumberModule();
	virtual ~CVCLineNumberModule();
public:	
	struct Settings 
	{
		COLORREF		m_clrTextColor;
		COLORREF		m_clrBKColor;
	};

	const Settings&		GetSettings() const { return m_stSettings; }

	CFont&				GetFont()			{ return m_font; }

	BOOL				UpdateFont();
protected:
	CVCLineNumberWnd*	GetLineNumberWndForMDIChildWnd(HWND hMDIChildWnd) const;
	CVCLineNumberWnd*	CreateLineNumberWndForMDIChildWnd(HWND hMDIChildWnd);
	void				CheckUpdateLineNumberWndForMDIChildWnd(HWND hMDIChildWnd);

	void				CreateLineNumberWndForExistingMDIChildWnds();
	void				DestroyAllLineNumberWnds();

	BOOL				Hook();
	BOOL				UnHook();

	virtual void		Enable(BOOL bEnable = TRUE);

	BOOL				LoadSettings();
	BOOL				SaveSettings();
protected:
	static LRESULT CALLBACK CallWndProcHook(int code, WPARAM wParam, LPARAM lParam);
protected:
	HHOOK					m_hWndProcHook;
	Settings				m_stSettings;
	CFont					m_font;
};

#endif // !defined(AFX_VCLINENUMBERMODULE_H__D308D456_3541_41CB_BFFB_44E4A97A809A__INCLUDED_)
