// VCLineNumberWnd.cpp: implementation of the CVCLineNumberWnd class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "VCLineNumberWnd.h"
#include "VCLineNumberModule.h"
#include "VCAddinManager.h"
#include "SubclassWnd.h"

class CLexDocTemplate;
class CAutoTextDoc;

// size == 164 (Non-derived 24)
class CPartDoc : public COleDocument
{
public:
	BYTE				m_arrBYTE[16];
	
	CLexDocTemplate*	m_pLexDocTemplate;
	
	CAutoTextDoc*		m_pAutoTextDoc;
};

// size == 180 (Non-derived 16)
class CIDEDoc : public CPartDoc
{
public:
	BYTE				m_arrBYTE[16];
};

class CDocTrackSlob;

// size == 20 (Non-derived 16)
class CSlob : public CObject
{
public:
	BYTE				m_arrBYTE1[8];
	
	CDocTrackSlob*		m_pDocTrackSlob;
	
	BYTE				m_arrBYTE2[4];	
};

// size == 24 (Non-derived 4)
class CTextDocSlob : public CSlob
{
public:
	BYTE				m_arrBYTE[4];
};

// size == 472 (Non-derived 292)
class CTextDoc : public CIDEDoc
{
public:
	// offset == 180
	BYTE				m_arrBYTE1[4];
	
	CObject*			m_pObject1;
	
	CPtrArray			m_PtrArray;			// size == 20
	
	BYTE				m_arrBYTE2[20];
	
	CTextDoc*			m_pTextDoc;
	
	// offset == 232
	BYTE				m_arrBYTE3[152];

	int					m_nMaxLineIndex;	// offset == 0x180 / 384

	BYTE				m_arrBYTE4[4];
	
	CTextDocSlob		m_TextDocSlob;		// size == 24
	
	BYTE				m_arrBYTE5[48];
	
	CLexDocTemplate*	m_pLexDocTemplate;
	
	CObject*			m_pObject2;	
};

class CPackage;

// size == 44 (Non-derived 12)
class CPack : public CCmdTarget
{
public:
	CPackage*			m_pPackage;
	
	BYTE				m_arrBYTE[8];
};

// size == 72 (Non-derived 28)
class CPackage : public CPack
{
public:
	BYTE				m_arrBYTE[28];
};

// size == 72 (Non-derived 4)
class CSlobWnd : public CView
{
public:
	CObList*			m_pObList;
};

// size == 76 (Non-derived 4)
class CPartView : public CSlobWnd
{
public:
	CPack*				m_pPack;	
};

// size == 80 (Non-derived 4)
class CIDEView: public CPartView
{
public:
	BYTE				m_arrBYTE[4];
};

class CAutoTextSel;

// size == 364 (Non-derived 284)
class CTextView : public CIDEView
{
public:
	// offset == 80
	BYTE				m_arrUnknownBYTE1[28];
	
	POINT				m_stCaretPos;
	
	BYTE				m_arrUnknownBYTE2[20];
	
	CAutoTextSel*		m_pAutoTextSel;
	
	// offset == 140
	BYTE				m_arrUnknownBYTE3[4];
	
	int					m_nTopLineIndex;			// offset == 0x90 / 144
	
	BYTE				m_arrUnknownBYTE4[12];
	
	CObject				m_Object1;					// size == 4
	
	BYTE				m_arrUnknownBYTE5[116];
	
	CObject				m_Object2;					// size == 4
	
	BYTE				m_arrUnknownBYTE6[4];
	
	CTextView*			m_pTextView;
	
	CCmdTarget			m_CmdTarget;
	
	BYTE				m_arrUnknownBYTE7[40];
};


/************************************************************************/
/* CAfxMDIFrameSubclassWnd                                              */
/************************************************************************/
class CAfxMDIFrameSubclassWnd : public CSubclassWnd
{
public:
	CAfxMDIFrameSubclassWnd(CVCLineNumberWnd& clLineNumberWnd);
	~CAfxMDIFrameSubclassWnd();
protected:
	BOOL	OnWindowPosChanging(LPWINDOWPOS lpwpos);
protected:
	BEGIN_MSG_DISPATCH(CAfxMDIFrameSubclassWnd, CSubclassWnd)
		DISPATCH_MSG(WM_WINDOWPOSCHANGING, OnWindowPosChanging)
	END_MSG_DISPATCH()
private:
	CVCLineNumberWnd& m_clLineNumberWnd;
};

CAfxMDIFrameSubclassWnd::CAfxMDIFrameSubclassWnd(CVCLineNumberWnd& clLineNumberWnd)
	: m_clLineNumberWnd(clLineNumberWnd)
{
	SubclassWindow( m_clLineNumberWnd.GetAfxMDIFrameWnd() );
}

CAfxMDIFrameSubclassWnd::~CAfxMDIFrameSubclassWnd()
{
}

BOOL CAfxMDIFrameSubclassWnd::OnWindowPosChanging(LPWINDOWPOS lpwpos)
{
	int nLineNumberWndWidth = m_clLineNumberWnd.UpdateWindowSize(TRUE);
	if ( !(lpwpos->flags & SWP_NOSIZE) && nLineNumberWndWidth > 0 )
	{
		int nOldX	= lpwpos->x;
		lpwpos->x	= nLineNumberWndWidth;
		lpwpos->cx	-= nLineNumberWndWidth - nOldX;
	}
	return (BOOL)DefWindowProc();
}

/************************************************************************/
/* CVCTextViewSubclassWnd                                               */
/************************************************************************/
class CVCTextViewSubclassWnd : public CSubclassWnd
{
public:
	CVCTextViewSubclassWnd(CVCLineNumberWnd& clLineNumberWnd);
	~CVCTextViewSubclassWnd();
public:
	void	ReSubclass();
protected:
	void	OnPaint();
protected:
	BEGIN_MSG_DISPATCH(CAfxMDIFrameSubclassWnd, CSubclassWnd)
		DISPATCH_MSG(WM_PAINT, OnPaint)
	END_MSG_DISPATCH()
private:
	CVCLineNumberWnd& m_clLineNumberWnd;
};

CVCTextViewSubclassWnd::CVCTextViewSubclassWnd(CVCLineNumberWnd& clLineNumberWnd)
	: m_clLineNumberWnd(clLineNumberWnd)
{
	SubclassWindow( m_clLineNumberWnd.GetView() );
}

CVCTextViewSubclassWnd::~CVCTextViewSubclassWnd()
{
}

void CVCTextViewSubclassWnd::OnPaint()
{
	DefWindowProc();
	m_clLineNumberWnd.Update();
}

void CVCTextViewSubclassWnd::ReSubclass()
{
	if ( !GetHandle() )
	{
		SubclassWindow( m_clLineNumberWnd.GetView() );
	}
}

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CVCLineNumberWnd::CVCLineNumberWnd()
	: m_hMDIChildWnd(NULL)
	, m_hViewWnd(NULL)
	, m_hAfxMDIFrameWnd(NULL)
	, m_hVScrollBarWnd(NULL)
	, m_pMDIChildSubclassWnd(NULL)
	, m_pVCTextViewSubclassWnd(NULL)
{
	ZeroMemory(&m_stLineNumberInfo, sizeof(m_stLineNumberInfo));
	m_nLineHeight		= 0;
	m_nBeginDrawYOffset = 0;
	m_nMaxDigitCount	= 0;
	m_bUpdating			= FALSE;
	m_pLineNumberModule	= NULL;

	m_nSubclassViewTimerId	= 0;

	RegisterWindowClass();
}

CVCLineNumberWnd::~CVCLineNumberWnd()
{
	ASSERT( !m_pMDIChildSubclassWnd );
	ASSERT( !m_pVCTextViewSubclassWnd );
}

BEGIN_MESSAGE_MAP(CVCLineNumberWnd, CVCLineNumberWndBase)
	ON_WM_CREATE()
	ON_WM_ERASEBKGND()
	ON_WM_PAINT()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_CONTEXTMENU()
	ON_WM_SETCURSOR()
	ON_WM_TIMER()
END_MESSAGE_MAP()

BOOL CVCLineNumberWnd::Create( HWND hMDIChildWnd )
{
	m_hMDIChildWnd = hMDIChildWnd;
	DWORD dwStyle = WS_CHILD|WS_VISIBLE;
	CRect rect(0,0,0,0);	// will be updated later
	return CWnd::Create(WC_LINENUMBER, _T(""), dwStyle, rect, CWnd::FromHandle(hMDIChildWnd), 1);
}

#define TIMER_SUBCLASS_VIEW_ID		123
#define TIMER_SUBCLASS_VIEW_ELAPSE	200

BOOL CVCLineNumberWnd::OnInitWnd()
{
	// Init the members (window handles)
	CWnd* pView				= GetView();
	CWnd* pAfxMDIFrameWnd	= GetAfxMDIFrameWnd();
	GetVertScrollBarCtrlHwnd();

	if ( pView && pAfxMDIFrameWnd )
	{
		CRect rcView, rcLineNumber;
		pView->GetWindowRect(rcView);
		pAfxMDIFrameWnd->GetWindowRect(rcLineNumber);
		m_nBeginDrawYOffset = rcView.top - rcLineNumber.top;
	}

	m_pLineNumberModule = (CVCLineNumberModule*)g_pAddinManager->GetModule(CVCAddinManager::AMT_LINENUMBER);

	//SetFont( &m_pLineNumberModule->GetFont(), FALSE );

	m_pMDIChildSubclassWnd		= new CAfxMDIFrameSubclassWnd(*this);
	m_pVCTextViewSubclassWnd	= new CVCTextViewSubclassWnd(*this);

	if ( !m_pVCTextViewSubclassWnd->GetHandle() )
	{
		m_nSubclassViewTimerId = SetTimer(TIMER_SUBCLASS_VIEW_ID, TIMER_SUBCLASS_VIEW_ELAPSE, NULL);
	}

	Update();

	return TRUE;
}

int CVCLineNumberWnd::OnCreate( LPCREATESTRUCT lpCreateStruct )
{
	if (CVCLineNumberWndBase::OnCreate(lpCreateStruct) == -1)
		return -1;
	OnInitWnd();
	return 0;
}

void CVCLineNumberWnd::PostNcDestroy()
{
	CVCLineNumberWndBase::PostNcDestroy();

	VCTRACE(_T("====== Destroying line number window for %s ======\n"), GetWndTraceInfo(m_hMDIChildWnd));

	delete m_pMDIChildSubclassWnd;
	delete m_pVCTextViewSubclassWnd;

	m_pMDIChildSubclassWnd		= NULL;
	m_pVCTextViewSubclassWnd	= NULL;

	if ( m_nSubclassViewTimerId )
	{
		VERIFY( KillTimer(m_nSubclassViewTimerId) );
		m_nSubclassViewTimerId = 0;
	}

	CMDIChildWnd* pMDIChildWnd = GetMDIChildWnd();
	if ( pMDIChildWnd )
	{
		CRect rect;
		pMDIChildWnd->GetWindowRect(rect);
		CWnd* pParent = pMDIChildWnd->GetParent();
		if ( pParent )
		{
			pParent->ScreenToClient(rect);
			--rect.left;
			pMDIChildWnd->MoveWindow(rect);	// this will reset the window layout
			
			pParent->Invalidate(TRUE);
			pParent->UpdateWindow();
		}
	}

	delete this;	// self-destroy
}

BOOL CVCLineNumberWnd::RegisterWindowClass()
{
	WNDCLASS wndcls;
	HINSTANCE hInstance = AfxGetInstanceHandle();
	if ( !GetClassInfo(hInstance, WC_LINENUMBER, &wndcls) )
	{
		ZeroMemory(&wndcls, sizeof(wndcls));
		
		wndcls.style			= CS_DBLCLKS | CS_VREDRAW | CS_GLOBALCLASS;
		wndcls.lpfnWndProc		= ::DefWindowProc;
		wndcls.hInstance		= hInstance;
		wndcls.hCursor			= ::LoadCursor(wndcls.hInstance, IDC_ARROW);
		wndcls.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
		wndcls.lpszClassName	= WC_LINENUMBER;
		
		return AfxRegisterClass(&wndcls);
	}
	return TRUE;
}

BOOL CVCLineNumberWnd::OnSetCursor( CWnd* pWnd, UINT nHitTest, UINT message )
{
	::SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
	return TRUE;
}

CMDIChildWnd* CVCLineNumberWnd::GetMDIChildWnd() const
{
	CMDIChildWnd *pChildFrameWnd = (CMDIChildWnd *)CWnd::FromHandle( m_hMDIChildWnd );	
	return pChildFrameWnd;
}

CWnd* CVCLineNumberWnd::GetView()
{
	if ( m_hViewWnd )
		return CWnd::FromHandle(m_hViewWnd);
	CMDIChildWnd *pChildFrameWnd = GetMDIChildWnd();
	if (pChildFrameWnd)
	{
		CView* pActiveView = pChildFrameWnd->GetActiveView();
		if ( pActiveView )
		{
			m_hViewWnd = pActiveView->GetSafeHwnd();
		}
		return pActiveView;
	}
	return NULL;
}

CWnd* CVCLineNumberWnd::GetAfxMDIFrameWnd()
{
	if ( !m_hAfxMDIFrameWnd )
	{
		m_hAfxMDIFrameWnd = ::FindWindowEx( m_hMDIChildWnd, NULL, WC_AFX_MDI_FRAMEWND, NULL);
	}
	return CWnd::FromHandle(m_hAfxMDIFrameWnd);
}

HWND CVCLineNumberWnd::GetVertScrollBarCtrlHwnd()
{
	return m_hVScrollBarWnd ? m_hVScrollBarWnd : (m_hVScrollBarWnd = ::FindScrollBarCtrl(m_hAfxMDIFrameWnd, SB_VERT));
}

CScrollBar* CVCLineNumberWnd::GetVertScrollBarCtrl()
{
	return (CScrollBar*)CWnd::FromHandle( GetVertScrollBarCtrlHwnd() );
}

CVCLineNumberModule* CVCLineNumberWnd::GetLineNumberModule() const
{
	return m_pLineNumberModule;
}

BOOL CVCLineNumberWnd::OnEraseBkgnd( CDC* pDC )
{
	return TRUE;	// we will take care of this in OnPaint()
}

#define LINE_NUMBER_RIGHT_SIDE_GAP		2
#define LINE_NUMBER_DT_FORMAT			(DT_RIGHT|DT_VCENTER|DT_SINGLELINE)

void CVCLineNumberWnd::OnPaint()
{
	int nLineCount = m_stLineNumberInfo.m_nLineIndexMax - m_stLineNumberInfo.m_nLineIndexMin + 1;
	if ( nLineCount <= 0 )
		return;

	CRect rcClient;
	GetClientRect(rcClient);
	
	CPaintDC dc(this);

	CDC dcMemory;
	if ( !dcMemory.CreateCompatibleDC(&dc) )
		return;

	CBitmap memBmp;
	if ( !memBmp.CreateCompatibleBitmap(&dc, rcClient.Width(), rcClient.Height()) )
		return;

	CFont& font = GetLineNumberModule()->GetFont();

	CBitmap* pOldBmp = dcMemory.SelectObject(&memBmp);
	CFont* pOldFont = dcMemory.SelectObject(&font);
	COLORREF clrOldTxtColor = dcMemory.SetTextColor(GetLineNumberModule()->GetSettings().m_clrTextColor);

	dcMemory.FillSolidRect(rcClient, GetLineNumberModule()->GetSettings().m_clrBKColor);

	int nOldBkMode = dcMemory.SetBkMode(TRANSPARENT);

	CRect rcLine(0,m_nBeginDrawYOffset,rcClient.right-LINE_NUMBER_RIGHT_SIDE_GAP,m_nLineHeight);

	for (int ii = 0; ii < nLineCount && rcLine.top <= rcClient.bottom; ++ii)
	{
		int nCurLineNumber = m_stLineNumberInfo.m_nLineIndexTop+ii+1;
		if ( nCurLineNumber > m_stLineNumberInfo.m_nLineIndexMax+1 )
			break;
		CString strLineText;
		strLineText.Format(_T("%d"), nCurLineNumber);

		int nHeight = dcMemory.DrawText(strLineText, rcLine, LINE_NUMBER_DT_FORMAT);

		rcLine.OffsetRect(0, m_nLineHeight);
	}

	dc.BitBlt(rcClient.left, rcClient.top, rcClient.Width(), rcClient.Height(), &dcMemory, 0, 0, SRCCOPY);

	dcMemory.SetBkMode(nOldBkMode);
	dcMemory.SetTextColor(clrOldTxtColor);
	dcMemory.SelectObject(pOldFont);
	dcMemory.SelectObject(pOldBmp);
}

BOOL CVCLineNumberWnd::CalcWindowRectForLineNumber( CRect& rcLineNumberWnd )
{
	CWnd* pAfxMDIFrameWnd = GetAfxMDIFrameWnd();
	if ( !pAfxMDIFrameWnd )
		return FALSE;
	
	CWnd* pParent = GetParent();
	if ( !pParent )
		return FALSE;
	
	int nLineCount = m_stLineNumberInfo.m_nLineIndexMax - m_stLineNumberInfo.m_nLineIndexMin + 1;
	if ( nLineCount <= 0 )
		return FALSE;
	
	CRect rcAfxMDIFrameWnd;
	pAfxMDIFrameWnd->GetWindowRect(rcAfxMDIFrameWnd);
	pParent->ScreenToClient(rcAfxMDIFrameWnd);
	
	GetWindowRect(rcLineNumberWnd);
	pParent->ScreenToClient(rcLineNumberWnd);
	
	rcLineNumberWnd.left	= 0;
	rcLineNumberWnd.top		= rcAfxMDIFrameWnd.top;
	rcLineNumberWnd.bottom	= rcAfxMDIFrameWnd.bottom;
	
	CString strLineText = _T("1");
	
	int nDigitCount	= 1;
	for (int nn = 1; nn <= nLineCount; nn *= 10)
	{
		++nDigitCount;
		strLineText += _T("0");
	}
	
	if (nDigitCount != m_nMaxDigitCount)
	{
		m_nMaxDigitCount = nDigitCount;
		
		CDC dc;
		dc.CreateCompatibleDC(NULL);
		
		CFont& font = GetLineNumberModule()->GetFont();
		
		CFont* pOldFont = dc.SelectObject(&font);
		
		CSize sizeText = dc.GetTextExtent(strLineText);
		m_nLineHeight = sizeText.cy;
		
		rcLineNumberWnd.right = rcLineNumberWnd.left + sizeText.cx + LINE_NUMBER_RIGHT_SIDE_GAP;
		
		dc.SelectObject(pOldFont);
	}
	return TRUE;
}

class CLineNumberUpdatingHelper
{
public:
	CLineNumberUpdatingHelper(CVCLineNumberWnd& clLineNumberWnd)
		: m_clLineNumberWnd(clLineNumberWnd)
	{
		m_clLineNumberWnd.m_bUpdating = TRUE;
	}
	~CLineNumberUpdatingHelper()
	{
		m_clLineNumberWnd.m_bUpdating = FALSE;
	}
protected:
	CVCLineNumberWnd& m_clLineNumberWnd;
};

int CVCLineNumberWnd::UpdateWindowSize(BOOL bRepaint /*= TRUE*/)
{
	if (m_bUpdating)
		return 0;
	
	CLineNumberUpdatingHelper clHelper(*this);

	CRect rcLineNumCtrl(0,0,0,0);
	CalcWindowRectForLineNumber(rcLineNumCtrl);

	MoveWindow(rcLineNumCtrl, bRepaint);
	Invalidate(bRepaint);
	
	return rcLineNumCtrl.Width();
}

void CVCLineNumberWnd::OnTimer( UINT nIDEvent )
{
	CVCLineNumberWndBase::OnTimer( nIDEvent );

	if ( m_nSubclassViewTimerId == nIDEvent )
	{
		m_pVCTextViewSubclassWnd->ReSubclass();
		if ( m_pVCTextViewSubclassWnd->GetHandle() )
		{
			VERIFY( KillTimer(m_nSubclassViewTimerId) );
			m_nSubclassViewTimerId = 0;
			Update();
		}
	}
}

void CVCLineNumberWnd::Update( BOOL bRepaint /*= TRUE*/ )
{
	if (m_bUpdating)
		return;
	
	CLineNumberUpdatingHelper clHelper(*this);

	CTextView* pTextView = (CTextView*)GetView();

	const int nTextViewSize	= sizeof(CTextView);
	const int nTextDocSize	= sizeof(CTextDoc);
	ASSERT( 364 == nTextViewSize && 472 == nTextDocSize );

	if ( pTextView && AfxIsValidAddress(pTextView, sizeof(CTextView)) )
	{
		m_stLineNumberInfo.m_nLineIndexTop = pTextView->m_nTopLineIndex;
		
		CTextDoc* pTextDoc = (CTextDoc*)pTextView->GetDocument();
		if ( pTextDoc && AfxIsValidAddress(pTextDoc, sizeof(CTextDoc)) )
		{
			m_stLineNumberInfo.m_nLineIndexMax = pTextDoc->m_nMaxLineIndex;
		}
	}

	if ( m_stLineNumberInfo.m_nLineIndexMax < 0 )
	{
		CScrollBar* pVScrollBar = GetVertScrollBarCtrl();
		if (pVScrollBar)
		{
			pVScrollBar->GetScrollRange(&m_stLineNumberInfo.m_nLineIndexMin, &m_stLineNumberInfo.m_nLineIndexMax);
		}
	}
	
	CRect rcLineNumCtrl(0,0,0,0);
	CalcWindowRectForLineNumber(rcLineNumCtrl);
	
	MoveWindow(rcLineNumCtrl, bRepaint);
	Invalidate(bRepaint);

	int nLineNumberCtrlWidth = rcLineNumCtrl.Width();

	CWnd* pAfxMDIFrameWnd	= GetAfxMDIFrameWnd();
	CWnd* pMDIChildWnd		= GetMDIChildWnd();
	if ( !pAfxMDIFrameWnd || !pMDIChildWnd )
		return;
		
	CRect rcFrame;
	pAfxMDIFrameWnd->GetWindowRect(rcFrame);
	pMDIChildWnd->ScreenToClient(rcFrame);
	
	rcFrame.left = nLineNumberCtrlWidth;

	pAfxMDIFrameWnd->MoveWindow(rcFrame, bRepaint);
}

int CVCLineNumberWnd::LineIndexFromPos( int nPos )
{
	int nOffset = nPos - m_nBeginDrawYOffset;
	if ( nOffset < 0 )
		return m_stLineNumberInfo.m_nLineIndexTop - 1;
	if (m_nLineHeight > 0)
	{
		int nLineOffset	= nOffset / m_nLineHeight;
		int nLineIndex	= m_stLineNumberInfo.m_nLineIndexTop + nLineOffset;
		if (nLineIndex <= m_stLineNumberInfo.m_nLineIndexMax)
			return nLineIndex;
	}
	return -1;
}

void CVCLineNumberWnd::OnLButtonDown( UINT nFlags, CPoint point )
{
	VCTRACE(_T("CVCLineNumberWnd::OnLButtonDown at %d\n"), LineIndexFromPos(point.y));

	CVCLineNumberWndBase::OnLButtonDown(nFlags, point);
}

void CVCLineNumberWnd::OnLButtonDblClk( UINT nFlags, CPoint point )
{
	VCTRACE(_T("CVCLineNumberWnd::OnLButtonDblClk at %d\n"), LineIndexFromPos(point.y));

	CVCLineNumberWndBase::OnLButtonDblClk(nFlags, point);
}

void CVCLineNumberWnd::OnContextMenu( CWnd* pWnd, CPoint pos )
{
	GetParent()->ScreenToClient(&pos);
	VCTRACE(_T("CVCLineNumberWnd::OnContextMenu at %d\n"), LineIndexFromPos(pos.y));

	CVCLineNumberWndBase::OnContextMenu(pWnd, pos);
}

