// VCLineNumberWnd.h: interface for the CVCLineNumberWnd class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_VCLINENUMBERWND_H__CC4E74E6_4A50_480D_8549_92ED7733CAAB__INCLUDED_)
#define AFX_VCLINENUMBERWND_H__CC4E74E6_4A50_480D_8549_92ED7733CAAB__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define WC_LINENUMBER		_T("LineNumberWnd")

class CVCLineNumberModule;
class CAfxMDIFrameSubclassWnd;
class CVCTextViewSubclassWnd;

#define CVCLineNumberWndBase	CWnd

/*----------------------------------------------------------------------------*/
/* CVCLineNumberWnd
/*----------------------------------------------------------------------------*/
class CVCLineNumberWnd : public CVCLineNumberWndBase
{
public:
	CVCLineNumberWnd();
	virtual ~CVCLineNumberWnd();
public:
	BOOL			Create(HWND hMDIChildWnd);
public:
	CMDIChildWnd*	GetMDIChildWnd() const;
	CWnd*			GetView();
	CWnd*			GetAfxMDIFrameWnd();
	CScrollBar*		GetVertScrollBarCtrl();
	HWND			GetVertScrollBarCtrlHwnd();

	int				LineIndexFromPos(int nPos);	// in client coordinates

	struct  LineNumberInfo
	{
		int	m_nLineIndexTop;
		int	m_nLineIndexMin;
		int	m_nLineIndexMax;
	};

	LineNumberInfo& GetLineNumberInfo()		{ return m_stLineNumberInfo; }
public:
	// returns the updated width
	int				UpdateWindowSize(BOOL bRepaint = TRUE);

	void			Update(BOOL bRepaint = TRUE);
protected:
	BOOL			OnInitWnd();

	BOOL			CalcWindowRectForLineNumber(CRect& rcLineNumberWnd);

	CVCLineNumberModule*	GetLineNumberModule() const;
protected:
	virtual BOOL	OnEraseBkgnd( CDC* pDC );
	virtual void	OnPaint();
	void			OnTimer(UINT nIDEvent);

	void			OnLButtonDown(UINT nFlags, CPoint point);
	void			OnLButtonDblClk(UINT nFlags, CPoint point);
	void			OnContextMenu(CWnd* pWnd, CPoint pos);
protected:
	int				OnCreate(LPCREATESTRUCT lpCreateStruct);
	void			PostNcDestroy();
	void			OnWindowPosChanging(WINDOWPOS* lpwndpos);

	BOOL			OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);

	BOOL			RegisterWindowClass();
protected:
	HWND					m_hMDIChildWnd;
	HWND					m_hViewWnd;
	HWND					m_hAfxMDIFrameWnd;
	HWND					m_hVScrollBarWnd;

	LineNumberInfo			m_stLineNumberInfo;

	int						m_nLineHeight;
	int						m_nBeginDrawYOffset;
	int						m_nMaxDigitCount;		// cache it for faster drawing, maybe.

	friend class CLineNumberUpdatingHelper;
	BOOL					m_bUpdating;

	CVCLineNumberModule*	m_pLineNumberModule;

	CAfxMDIFrameSubclassWnd*	m_pMDIChildSubclassWnd;
	CVCTextViewSubclassWnd*		m_pVCTextViewSubclassWnd;

	UINT_PTR				m_nSubclassViewTimerId;
protected:
	DECLARE_MESSAGE_MAP()
};

#endif // !defined(AFX_VCLINENUMBERWND_H__CC4E74E6_4A50_480D_8549_92ED7733CAAB__INCLUDED_)
